/*
 * Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
 *
 * The implementation of the VPScript class.
 */


#include <gtk/gtkobject.h>

#include "gvpinterpreter.h"

#include "gvpscript.h"


static void vp_script_class_init(VPScriptClass *);
static void vp_script_init(VPScript *);


/*
 * Return the type ID.
 */
 
guint vp_script_get_type(void)
{
        static guint script_type = 0;
 
        if (script_type == 0)
        {
                static const GtkTypeInfo script_info = {
                        "VPScript",
                        sizeof (VPScript),
                        sizeof (VPScriptClass),
                        (GtkClassInitFunc)vp_script_class_init,
                        (GtkObjectInitFunc)vp_script_init,
                };
 
                script_type = gtk_type_unique(gtk_object_get_type(),&script_info);
	}
 
        return script_type;
}


/*
 * Initialise the class structure.
 */
 
static void vp_script_class_init(VPScriptClass *sc)
{
}
 
 
/*
 * Initialise the instance structure.
 */
 
static void vp_script_init(VPScript *this)
{
	this -> interp = NULL;
	this -> script = NULL;
}


/*
 * Create a script.
 */

GtkObject *vp_script_new(char *script,GtkObject *interp)
{
	VPScript *this;

	this = gtk_type_new(vp_script_get_type());

	this -> interp = interp;
	this -> script = script;

	return GTK_OBJECT(this);
}


/*
 * Execute a script.
 */

void vp_script_execute(GtkObject *o)
{
	VPScript *this;

	g_return_if_fail(o != NULL);
	g_return_if_fail(VP_IS_SCRIPT(o));

	this = VP_SCRIPT(o);

	vp_interpreter_execute(this -> interp,this -> script);
}
