/*
 * Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
 *
 * This handles the GNOME implementation of the PieChart and Graph classes.
 */


#include <Python.h>
#include <gnome.h>

#include "gvpmodint.h"


/* Extra information we need to keep with a chart. */
 
struct chartContext {
	PyObject	*pyobj;		/* The corresponding Python object. */
};


/*
 * The ctor.
 */

void *gvpChartCtor(PyObject *po,void *parent,int width,int height)
{
	GtkWidget *gc;
	struct chartContext *ccp;
 
	if ((ccp = Py_Malloc(sizeof (struct chartContext))) == NULL)
		return NULL;
 
	ccp -> pyobj = po;
 
	/* Create the chart. */
 
	gc = gtk_type_new(gnome_pixmap_get_type());
 
	gvpWidgetInit(gc,ccp);
 
	return gc;
}


/*
 * The plot method.
 */

void gvpChartPlot(void *self,void *image,int image_size)
{
	GtkWidget *gc = (GtkWidget *)self;
	GdkImlibImage *im;

	if ((im = gdk_imlib_inlined_png_to_image(image,image_size)) != NULL)
		gnome_pixmap_load_imlib(GNOME_PIXMAP(gc),im);
}
