/*
 * Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
 *
 * This handles the GNOME implementation of the Color class.
 */


#include <Python.h>
#include <gdk/gdktypes.h>

#include "gvpmodint.h"


/*
 * The dtor.
 */

void gvpColorDtor(void *ptr)
{
	Py_Free((ANY *)ptr);
}


/*
 * The ctor.
 */

void *gvpColorCtor(PyObject *po,pymodColorDef *cd)
{
	GdkColor *gcp;

	if ((gcp = Py_Malloc(sizeof (GdkColor))) == NULL)
		return NULL;

	/*
	 * At the moment we don't use colors anywhere with Gtk, so don't worry
	 * about the pixel value yet.
	 */

	gcp -> red = cd -> red;
	gcp -> green = cd -> green;
	gcp -> blue = cd -> blue;

	return gcp;
}


/*
 * Set the rgb property.
 */

int gvpColorSetRGB(void *self,pymodColorDef *cd)
{
	GdkColor *gcp = (GdkColor *)self;

	gcp -> red = cd -> red;
	gcp -> green = cd -> green;
	gcp -> blue = cd -> blue;

	return 0;
}
