/*
 * Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
 *
 * This handles the GNOME implementation of the Grid class.
 */


#include <Python.h>
#include <gtk/gtktable.h>

#include "gvpmodint.h"


/* Extra information we need to keep with a grid. */
 
struct gridContext {
	PyObject	*pyobj;		/* The corresponding Python object. */
};


/*
 * The ctor.
 */

void *gvpGridCtor(PyObject *po,void *parent)
{
	GtkWidget *gg;
	struct gridContext *gcp;
 
	if ((gcp = Py_Malloc(sizeof (struct gridContext))) == NULL)
		return NULL;
 
	gcp -> pyobj = po;
 
	/* Create the label. */
 
	gg = gtk_table_new(1,1,FALSE);
 
	gvpWidgetInit(gg,gcp);
 
	return gg;
}


/*
 * Add a child.
 */

void gvpGridAddChild(void *self,void *child,int row,int col)
{
	GtkWidget *gg = (GtkWidget *)self;
 
	gtk_table_attach(GTK_TABLE(gg),(GtkWidget *)child,
				col,col + 1,
				row,row + 1,
				0,0,0,0);
}
