/*
 * Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
 *
 * This header files defines the internal interfaces of the GNOME
 * implementation of the Python module.
 */


#ifndef _GVPMODINT_H
#define	_GVPMODINT_H

#include <gtk/gtkwidget.h>

#include "pymod.h"


/* These are the driver functions. */

void gvpColorDtor(void *);
void *gvpColorCtor(PyObject *,pymodColorDef *);
int gvpColorSetRGB(void *,pymodColorDef *);

void *gvpChartCtor(PyObject *,void *,int,int);
void gvpChartPlot(void *,void *,int);

void *gvpGridCtor(PyObject *,void *);
void gvpGridAddChild(void *,void *,int,int);

void *gvpHBoxCtor(PyObject *,void *);
void gvpHBoxAddChild(void *,void *);

void *gvpVBoxCtor(PyObject *,void *);
void gvpVBoxAddChild(void *,void *);

void *gvpLabelCtor(PyObject *,void *,char *);
int gvpLabelSetText(void *,char *);

void gvpApplicationWindowAddChild(void *,void *);
void gvpApplicationWindowUpdate(void *,void *);

void gvpMessageError(char *,void *,char *);
void gvpMessageInformation(char *,void *,char *);
int gvpMessageQuestion(char *,void *,char *,char *,char *);
void gvpMessageSorry(char *,void *,char *);
int gvpMessageWarning(char *,void *,char *,int,char *,char *,char *);

void *gvpDialogCtor(PyObject *,void *,char *,int,char *,int,int,char *,char *);
void gvpDialogAddChild(void *,void *);
void gvpDialogHide(void *);
void gvpDialogShow(void *);
int gvpDialogSetTitle(void *,char *);

int gvpGetBackground(void *,pymodColorDef *);

/* These are utility functions. */

void gvpDtor(void *);
void gvpWidgetInit(GtkWidget *,gpointer);
void gvpDialogSetParent(GtkWidget *,void *);

#endif
