/*
 * Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
 *
 * This handles the GNOME implementation of the HBox class.
 */


#include <Python.h>
#include <gtk/gtkhbox.h>

#include "gvpmodint.h"


/* Extra information we need to keep with a hbox. */
 
struct hBoxContext {
	PyObject	*pyobj;		/* The corresponding Python object. */
};

/*
 * The ctor.
 */

void *gvpHBoxCtor(PyObject *po,void *parent)
{
	GtkWidget *ghb;
	struct hBoxContext *hbcp;
 
	if ((hbcp = Py_Malloc(sizeof (struct hBoxContext))) == NULL)
		return NULL;
 
	hbcp -> pyobj = po;
 
	/* Create the label. */
 
	ghb = gtk_hbox_new(FALSE,0);
 
	gvpWidgetInit(ghb,hbcp);
 
	return ghb;
}


/*
 * Add a child.
 */

void gvpHBoxAddChild(void *self,void *child)
{
	GtkWidget *ghb = (GtkWidget *)self;
 
	gtk_box_pack_start(GTK_BOX(ghb),(GtkWidget *)child,FALSE,FALSE,0);
}
