/*
 * Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
 *
 * This handles the initialisation of the GNOME version of the Python module.
 */


#include "gvpmodint.h"


/*
 * The Python module initialisation function.
 */

void initlibgvp()
{
	static pymodColorDrivers colorDrivers = {
		gvpColorDtor,
		gvpColorCtor,
		gvpColorSetRGB
	};

	static pymodGridDrivers gridDrivers = {
		gvpDtor,
		gvpGridCtor,
		gvpGridAddChild
	};

	static pymodHBoxDrivers hBoxDrivers = {
		gvpDtor,
		gvpHBoxCtor,
		gvpHBoxAddChild
	};

	static pymodVBoxDrivers vBoxDrivers = {
		gvpDtor,
		gvpVBoxCtor,
		gvpVBoxAddChild
	};

	static pymodPieChartDrivers pieChartDrivers = {
		gvpDtor,
		gvpChartCtor,
		gvpChartPlot
	};

	static pymodGraphDrivers graphDrivers = {
		gvpDtor,
		gvpChartCtor,
		gvpChartPlot
	};

	static pymodLabelDrivers labelDrivers = {
		gvpDtor,
		gvpLabelCtor,
		gvpLabelSetText
	};

	static pymodApplicationWindowDrivers applicationWindowDrivers = {
		0,
		gvpApplicationWindowAddChild,
		gvpApplicationWindowUpdate,
		gvpGetBackground
	};

	static pymodMessageDrivers messageDrivers = {
		gvpMessageError,
		gvpMessageInformation,
		gvpMessageQuestion,
		gvpMessageSorry,
		gvpMessageWarning
	};

	static pymodDialogDrivers dialogDrivers = {
		gvpDtor,
		gvpDialogCtor,
		gvpDialogAddChild,
		gvpDialogHide,
		gvpDialogShow,
		gvpDialogSetTitle,
		gvpGetBackground
	};

	pymodInit("libgvp",
			&colorDrivers,
			&gridDrivers,
			&hBoxDrivers,
			&vBoxDrivers,
			&pieChartDrivers,
			&graphDrivers,
			&labelDrivers,
			&applicationWindowDrivers,
			&messageDrivers,
			&dialogDrivers);
}
