/*
 * Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
 *
 * This handles the GNOME implementation of the Label class.
 */


#include <Python.h>
#include <gtk/gtklabel.h>

#include "gvpmodint.h"


/* Extra information we need to keep with a label. */

struct labelContext {
	PyObject	*pyobj;		/* The corresponding Python object. */
};


/*
 * The ctor.
 */

void *gvpLabelCtor(PyObject *po,void *parent,char *text)
{
	GtkWidget *gl;
	struct labelContext *lcp;

	if ((lcp = Py_Malloc(sizeof (struct labelContext))) == NULL)
		return NULL;

	lcp -> pyobj = po;

	/* Create the label. */

	gl = gtk_label_new(text);

	gvpWidgetInit(gl,lcp);

	return gl;
}


/*
 * Set the text property.
 */

int gvpLabelSetText(void *self,char *text)
{
	gtk_label_set_text((GtkLabel *)self,text);

	return 0;
}
