/*
 * Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
 *
 * This handles the GNOME implementation of the VBox class.
 */


#include <Python.h>
#include <gtk/gtkvbox.h>

#include "gvpmodint.h"


/* Extra information we need to keep with a vbox. */
 
struct vBoxContext {
	PyObject	*pyobj;		/* The corresponding Python object. */
};

/*
 * The ctor.
 */

void *gvpVBoxCtor(PyObject *po,void *parent)
{
	GtkWidget *gvb;
	struct vBoxContext *vbcp;
 
	if ((vbcp = Py_Malloc(sizeof (struct vBoxContext))) == NULL)
		return NULL;
 
	vbcp -> pyobj = po;
 
	/* Create the label. */
 
	gvb = gtk_vbox_new(FALSE,0);
 
	gvpWidgetInit(gvb,vbcp);
 
	return gvb;
}


/*
 * Add a child.
 */

void gvpVBoxAddChild(void *self,void *child)
{
	GtkWidget *gvb = (GtkWidget *)self;
 
	gtk_box_pack_start(GTK_BOX(gvb),(GtkWidget *)child,FALSE,FALSE,0);
}
