/*
 * Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
 *
 * This module implements the main window.
 */


#include <gnome.h>

#include <gvpinterpreter.h>

#include "gvpshell.h"


static gint deleteAppWin(GtkWidget *,GdkEventAny *,gpointer);


GtkWidget *gvpshell_new(const char *appid,GtkWidget **dareap)
{
	GtkWidget *w, *f;

	w = gnome_app_new(appid,_("GNOME Visual Python Shell"));

	gtk_signal_connect(GTK_OBJECT(w),"delete_event",GTK_SIGNAL_FUNC(deleteAppWin),NULL);

	/* Create the drawing area. */

	f = gtk_frame_new(NULL);
	gtk_frame_set_shadow_type(GTK_FRAME(f),GTK_SHADOW_NONE);

	gnome_app_set_contents(GNOME_APP(w),f);

	*dareap = f;

	return w;
}


/*
 * The script failed slot.
 */

void gvpshell_script_failed_slot(GtkObject *interp,gchar *script,gchar *message,gpointer data)
{
	gchar buf[200];
	GtkWidget *d;

	g_snprintf(buf,sizeof (buf),"%s: %s",script,message);

	d = gnome_error_dialog_parented(buf,GTK_WINDOW(data));

	gtk_widget_show(d);
}


/*
 * The internal error slot.
 */

void gvpshell_internal_error_slot(GtkObject *interp,gchar *message,gpointer data)
{
	GtkWidget *d;

	d = gnome_error_dialog_parented(message,GTK_WINDOW(data));

	gtk_widget_show(d);
}


/*
 * The delete callback for the main window.
 */

static gint deleteAppWin(GtkWidget *w,GdkEventAny *ev,gpointer data)
{
	gtk_main_quit();

	return FALSE;
}
