// Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
//
// The interface to the VPInterpreter class.


#ifndef VPINTERPRETER_H
#define VPINTERPRETER_H


#include <qwidget.h>
#include <qstring.h>


extern "C" {struct pylibContext;}

class VPValue;


class VPInterpreter : public QObject
{
	Q_OBJECT

public:
	VPInterpreter(QWidget *appWin);
	virtual ~VPInterpreter();

	static VPInterpreter *main;

	void setVPInitCode(char *code) { m_pre1code = code; }
	void setAppInitCode(char *code) { m_pre2code = code; }
	void execute(char *script);
	void setAppDoneCode(char *code) { m_postcode = code; }

	void addApplicationWindow(QWidget *appWin,const char *name = 0);
	void removeApplicationWindow(QWidget *appWin);

	void setArgv(int argc,char **argv,QWidget *appWin = 0);
	void setSignals(char **signames);

	void emitSignal(char *signame,VPValue *val = 0,QWidget *appWin = 0);

	// These are for internal use.

	static struct pylibContext *getContext(VPInterpreter *interp);
	void emitInternalError(const char *message);

signals:
	void scriptFailed(const char *script,const char *message);
	void internalError(const char *message);

private:
	char *m_pre1code;
	char *m_pre2code;
	char *m_postcode;
	struct pylibContext *m_context;

	VPInterpreter(const VPInterpreter &);
	VPInterpreter &operator=(const VPInterpreter &);
};

#endif
