// Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
//
// The interface to the VPValue, VPValueDict and VPValueList classes.


#ifndef VPVALUE_H
#define VPVALUE_H


#include <Python.h>
#include <kvpinterpreter.h>


class VPValue
{
public:
	VPValue(const char *strval,VPInterpreter *interp = 0);
	VPValue(long longval,VPInterpreter *interp = 0);
	VPValue(double doubleval,VPInterpreter *interp = 0);
	virtual ~VPValue();

	struct pylibContext *getContext() {return m_context; }
	PyObject *getPyObj() {return m_pyobj; }

protected:
	VPValue(VPInterpreter *interp)
	{
		setContext(interp);
	}

	PyObject *m_pyobj;

private:
	void setContext(VPInterpreter *interp)
	{
		m_context = VPInterpreter::getContext(interp);
	}

	struct pylibContext *m_context;

	VPValue(const VPValue &);
	VPValue &operator=(const VPValue &);
};


class VPValueDict : public VPValue
{
public:
	VPValueDict(VPInterpreter *interp = 0);

	void set(VPValue *key,VPValue *val);

private:
	VPValueDict(const VPValueDict &);
	VPValueDict &operator=(const VPValueDict &);
};


class VPValueList : public VPValue
{
public:
	VPValueList(VPInterpreter *interp = 0);

	void append(VPValue *val);

private:
	VPValueList(const VPValueList &);
	VPValueList &operator=(const VPValueList &);
};

#endif
