// Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
//
// This handles the KDE implementation of the Grid class.


#include <qwidget.h>
#include <qlayout.h>
#include <kdialogbase.h>

#include "kvpmodint.h"


// We need to sub-class the Qt grid to add some extras.

class kvpGrid : public QWidget
{
public:
	kvpGrid(PyObject *,QWidget *);
	~kvpGrid();

	void addChild(QWidget *,int,int);
 
private:
	PyObject *pyobj;		// The corresponding Python object.
	QGridLayout *lay;		// The layout manager.
 
	kvpGrid(const kvpGrid &);
	kvpGrid &operator=(const kvpGrid &);
};


// The kvpGrid ctor.
 
kvpGrid::kvpGrid(PyObject *po,QWidget *parent) :
        QWidget(parent)
{
	pyobj = po;

	lay = new QGridLayout(this);

	if (parent -> isA("KDialogBase"))
		lay -> setSpacing(KDialog::spacingHint());
}
 
 
// The kvpGrid dtor.
 
kvpGrid::~kvpGrid()
{
	pymodWidgetDeleted(pyobj);
}


// Add a child widget.

void kvpGrid::addChild(QWidget *child,int row,int col)
{
	lay -> addWidget(child,row,col);
}


// The dtor.

extern "C" void kvpGridDtor(void *ptr)
{
	delete (kvpGrid *)ptr;
}


// The ctor.

extern "C" void *kvpGridCtor(PyObject *po,void *parent)
{
	return new kvpGrid(po,(QWidget *)parent);
}


// Add a child.

extern "C" void kvpGridAddChild(void *self,void *child,int row,int col)
{
	((kvpGrid *)self) -> addChild((QWidget *)child,row,col);
}
