// Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
//
// This handles the KDE implementation of the HBox class.


#include <qwidget.h>
#include <qlayout.h>
#include <kdialogbase.h>

#include "kvpmodint.h"


// We need to sub-class the Qt box to add some extras.

class kvpHBox : public QWidget
{
public:
	kvpHBox(PyObject *,QWidget *);
	~kvpHBox();

	void addChild(QWidget *);
 
private:
	PyObject *pyobj;		// The corresponding Python object.
	QHBoxLayout *lay;		// The layout manager.
 
	kvpHBox(const kvpHBox &);
	kvpHBox &operator=(const kvpHBox &);
};


// The kvpHBox ctor.
 
kvpHBox::kvpHBox(PyObject *po,QWidget *parent) :
        QWidget(parent)
{
	pyobj = po;

	lay = new QHBoxLayout(this);

	if (parent -> isA("KDialogBase"))
		lay -> setSpacing(KDialog::spacingHint());
}
 
 
// The kvpHBox dtor.
 
kvpHBox::~kvpHBox()
{
	pymodWidgetDeleted(pyobj);
}


// Add a child widget.

void kvpHBox::addChild(QWidget *child)
{
	lay -> addWidget(child);
}


// The dtor.

extern "C" void kvpHBoxDtor(void *ptr)
{
	delete (kvpHBox *)ptr;
}


// The ctor.

extern "C" void *kvpHBoxCtor(PyObject *po,void *parent)
{
	return new kvpHBox(po,(QWidget *)parent);
}


// Add a child.

extern "C" void kvpHBoxAddChild(void *self,void *child)
{
	((kvpHBox *)self) -> addChild((QWidget *)child);
}
