// Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
//
// This handles the initialisation of the KDE version of the Python module.


#include "kvpmodint.h"


// The Python module initialisation function.

extern "C" void initlibkvp()
{
	static pymodColorDrivers colorDrivers = {
		kvpColorDtor,
		kvpColorCtor,
		kvpColorSetRGB
	};

	static pymodGridDrivers gridDrivers = {
		kvpGridDtor,
		kvpGridCtor,
		kvpGridAddChild
	};

	static pymodHBoxDrivers hBoxDrivers = {
		kvpHBoxDtor,
		kvpHBoxCtor,
		kvpHBoxAddChild
	};

	static pymodVBoxDrivers vBoxDrivers = {
		kvpVBoxDtor,
		kvpVBoxCtor,
		kvpVBoxAddChild
	};

	static pymodPieChartDrivers pieChartDrivers = {
		kvpChartDtor,
		kvpChartCtor,
		kvpChartPlot
	};

	static pymodGraphDrivers graphDrivers = {
		kvpChartDtor,
		kvpChartCtor,
		kvpChartPlot
	};

	static pymodLabelDrivers labelDrivers = {
		kvpLabelDtor,
		kvpLabelCtor,
		kvpLabelSetText
	};

	static pymodApplicationWindowDrivers applicationWindowDrivers = {
		0,
		0,
		kvpApplicationWindowUpdate,
		kvpGetBackground
	};

	static pymodMessageDrivers messageDrivers = {
		kvpMessageError,
		kvpMessageInformation,
		kvpMessageQuestion,
		kvpMessageSorry,
		kvpMessageWarning
	};

	static pymodDialogDrivers dialogDrivers = {
		kvpDialogDtor,
		kvpDialogCtor,
		kvpDialogAddChild,
		kvpDialogHide,
		kvpDialogShow,
		kvpDialogSetTitle,
		kvpGetBackground
	};

	pymodInit("libkvp",
			&colorDrivers,
			&gridDrivers,
			&hBoxDrivers,
			&vBoxDrivers,
			&pieChartDrivers,
			&graphDrivers,
			&labelDrivers,
			&applicationWindowDrivers,
			&messageDrivers,
			&dialogDrivers);
}
