// Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
//
// This handles the KDE implementation of the Label class.


#include <qlabel.h>

#include "kvpmodint.h"


// We need to sub-class the Qt label to add some extras.

class kvpLabel : public QLabel
{
public:
	kvpLabel(PyObject *,QWidget *);
	~kvpLabel();
 
private:
	PyObject *pyobj;		// The corresponding Python object.
 
	kvpLabel(const kvpLabel &);
	kvpLabel &operator=(const kvpLabel &);
};


// The kvpLabel ctor.
 
kvpLabel::kvpLabel(PyObject *po,QWidget *parent) :
        QLabel(parent)
{
	pyobj = po;
}
 
 
// The kvpLabel dtor.
 
kvpLabel::~kvpLabel()
{
	pymodWidgetDeleted(pyobj);
}


// The dtor.

extern "C" void kvpLabelDtor(void *ptr)
{
	delete (kvpLabel *)ptr;
}


// The ctor.

extern "C" void *kvpLabelCtor(PyObject *po,void *parent,char *text)
{
	kvpLabel *kl = new kvpLabel(po,(QWidget *)parent);

	if (kl)
	{
		// We dumb down KDE to GNOME's level.

		kl -> setTextFormat(Qt::PlainText);
		kl -> setText(text);
	}

	return kl;
}


// Set the text property.

extern "C" int kvpLabelSetText(void *self,char *text)
{
	((kvpLabel *)self) -> setText(text);

	return 0;
}
