// Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
//
// This handles the KDE implementation of the Message class.


#include <kmessagebox.h>
#include <klocale.h>

#include "kvpmodint.h"


// The static method error.

extern "C" void kvpMessageError(char *text,void *parent,char *title)
{
	KMessageBox::error((QWidget *)parent,text,title);
}


// The static method sorry.

extern "C" void kvpMessageSorry(char *text,void *parent,char *title)
{
	KMessageBox::sorry((QWidget *)parent,text,title);
}


// The static method information.

extern "C" void kvpMessageInformation(char *text,void *parent,char *title)
{
	KMessageBox::information((QWidget *)parent,text,title);
}


// The static method question.

extern "C" int kvpMessageQuestion(char *text,void *parent,char *title,char *notext, char *yestext)
{
	return (KMessageBox::questionYesNo((QWidget *)parent,text,title,yestext,notext) == KMessageBox::Yes ? PYMOD_DIALOG_BUTTON_YES : PYMOD_DIALOG_BUTTON_NO);
}


// The static method warning.

extern "C" int kvpMessageWarning(char *text,void *parent,char *title,int butts,char *continuetext,char *notext,char *yestext)
{
	int kbutt, butt;

	// Use the required version of the message box.

	switch (butts)
	{
	case PYMOD_DIALOG_BUTTON_YES|PYMOD_DIALOG_BUTTON_NO:
		kbutt = KMessageBox::warningYesNo((QWidget *)parent,text,title,yestext,notext);
		break;

	case PYMOD_DIALOG_BUTTON_CONTINUE|PYMOD_DIALOG_BUTTON_CANCEL:
		kbutt = KMessageBox::warningContinueCancel((QWidget *)parent,text,title,(continuetext != NULL ? QString(continuetext) : i18n("C&ontinue")));
		break;

	case PYMOD_DIALOG_BUTTON_YES|PYMOD_DIALOG_BUTTON_NO|PYMOD_DIALOG_BUTTON_CANCEL:
		kbutt = KMessageBox::warningYesNoCancel((QWidget *)parent,text,title,yestext,notext);
		break;
	}

	// Convert the button.

	switch (kbutt)
	{
	case KMessageBox::Yes:
		butt = PYMOD_DIALOG_BUTTON_YES;
		break;

	case KMessageBox::No:
		butt = PYMOD_DIALOG_BUTTON_NO;
		break;

	case KMessageBox::Continue:
		butt = PYMOD_DIALOG_BUTTON_CONTINUE;
		break;

	case KMessageBox::Cancel:
		butt = PYMOD_DIALOG_BUTTON_CANCEL;
		break;
	}

	return butt;
}
