// Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
//
// This handles the KDE implementation of the VBox class.


#include <qwidget.h>
#include <qlayout.h>
#include <kdialogbase.h>

#include "kvpmodint.h"


// We need to sub-class the Qt box to add some extras.

class kvpVBox : public QWidget
{
public:
	kvpVBox(PyObject *,QWidget *);
	~kvpVBox();

	void addChild(QWidget *);
 
private:
	PyObject *pyobj;		// The corresponding Python object.
	QVBoxLayout *lay;		// The layout manager.
 
	kvpVBox(const kvpVBox &);
	kvpVBox &operator=(const kvpVBox &);
};


// The kvpVBox ctor.
 
kvpVBox::kvpVBox(PyObject *po,QWidget *parent) :
        QWidget(parent)
{
	pyobj = po;

	lay = new QVBoxLayout(this);

	if (parent -> isA("KDialogBase"))
		lay -> setSpacing(KDialog::spacingHint());
}
 
 
// The kvpVBox dtor.
 
kvpVBox::~kvpVBox()
{
	pymodWidgetDeleted(pyobj);
}


// Add a child widget.

void kvpVBox::addChild(QWidget *child)
{
	lay -> addWidget(child);
}


// The dtor.

extern "C" void kvpVBoxDtor(void *ptr)
{
	delete (kvpVBox *)ptr;
}


// The ctor.

extern "C" void *kvpVBoxCtor(PyObject *po,void *parent)
{
	return new kvpVBox(po,(QWidget *)parent);
}


// Add a child.

extern "C" void kvpVBoxAddChild(void *self,void *child)
{
	((kvpVBox *)self) -> addChild((QWidget *)child);
}
