// Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
//
// This implements the main application widget.


#include <kapp.h>
#include <qwidget.h>
#include <qfiledialog.h>
#include <kmessagebox.h>

#include <kvpscript.h>

#include "kvpshell.moc"


KVPShell::KVPShell() :
	m_view(new QWidget(this))
{
	setView(m_view);
}


KVPShell::~KVPShell()
{
}


// Slot to handle script failures.

void KVPShell::scriptFailed(const char *script,const char *message)
{
	QString msg(script);

	KMessageBox::sorry(this,msg + ": " + message);
}


// Slot to handle interpreter internal errors.

void KVPShell::internalError(const char *message)
{
	KMessageBox::error(this,message);
}
