/*
 * Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
 *
 * This header files defines the interface between the GUI dependent and
 * independent parts of the application API to VP.
 */


#ifndef _PYLIB_H
#define	_PYLIB_H

#include <Python.h>

#ifdef __cplusplus
extern "C" {
#endif


struct pylibContext;

struct pylibContext *pylibInit(void (*)(const char *,void *),void *);
void pylibDone(struct pylibContext *,char *);
void pylibAddAppWindow(struct pylibContext *,void *,const char *);
void pylibRemoveAppWindow(struct pylibContext *,void *);
void pylibSetAppWindowArgv(struct pylibContext *,void *,int,char **);
void pylibSetAppWindowSignals(struct pylibContext *,char **);
void pylibEmitAppWindowSignal(struct pylibContext *,void *,char *,PyObject *);
const char *pylibExec(struct pylibContext *,char *,char *,char *);
PyObject *pylibValueCtorString(struct pylibContext *,const char *);
PyObject *pylibValueCtorLong(struct pylibContext *,long);
PyObject *pylibValueCtorDouble(struct pylibContext *,double);
void pylibValueDtor(struct pylibContext *,PyObject *);
PyObject *pylibValueDictCtor(struct pylibContext *);
void pylibValueDictSet(struct pylibContext *,PyObject *,PyObject *,PyObject *);
PyObject *pylibValueListCtor(struct pylibContext *);
void pylibValueListAppend(struct pylibContext *,PyObject *,PyObject *);


#ifdef __cplusplus
}
#endif

#endif
