/*
 * Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
 *
 * This header files defines the internal interface of the GUI independent
 * parts of the application API to VP.
 */


#ifndef _PYLIBINT_H
#define	_PYLIBINT_H

#include "pylib.h"
#include "pylibmod.h"


/* This defines an interpreter context. */

struct pylibContext {
	int		ranScript;		/* We have run a script. */
	void		(*eHandler)(const char *,void *);	/* Error handler. */
	PyThreadState	*thread;		/* The Python thread. */
	pylibAppWindow	*appWindows;		/* App windows. */
	void		*tkData;		/* Toolkit data. */
};


int pylibDoneFirstScript(void);
pylibAppWindow *pylibDeleteAppWindow(pylibAppWindow *);

#endif
