/*
 * This files defines the private interfaces between the different modules of
 * the charting library.
 */


#ifndef _GDCHARTINT_H
#define _GDCHARTINT_H


#include <gd.h>

#include "gdchart.h"


#define ABS(x)		((x) < 0.0 ? -(x) : (x))
#define MAX(x,y)	((x) > (y) ? (x) : (y))
#define MIN(x,y)	((x) < (y) ? (x) : (y)) 


struct GDC_FONT_T {
	gdFontPtr	f;
	int		h;
	int		w;
};

typedef enum {
	GDC_JUSTIFY_RIGHT,
	GDC_JUSTIFY_CENTER,
	GDC_JUSTIFY_LEFT
} GDC_justify_t;


extern struct GDC_FONT_T GDC_fontc[];


void GDC_ImageStringNL(gdImagePtr,struct GDC_FONT_T *,int,int,char *,int,GDC_justify_t);
void GDC_load_font_conversions();
int GDC_cnt_nl(char *,int *);
int GDC_get_title_height(GDC_AttributeValues *);
gdImage *GDC_create_or_restore_image(GDC_AttributeValues *,int,int);
void GDC_save_or_destroy_image(GDC_AttributeValues *,gdImage *);
void GDC_draw_title(GDC_AttributeValues *,gdImage *,int);
char *GDC_price_to_str(float,int *,int *,int *,char *);
int GDC_alloc_color(GDC_AttributeValues *,gdImage *,unsigned long);
int GDC_alloc_color_shadow(GDC_AttributeValues *,gdImage *,unsigned long);

#endif
