/*
 * Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
 *
 * This module implements the Python part of the GraphSeries class.
 */


#include <stddef.h>

#include "pymodint.h"


static int graphSeriesCtor(pymodPyBase *,PyObject *,PyObject *);
static int graphSeriesValuesConvFrom(PyObject *,void *,propValidDef *,int);


/*****************************************************************************/
/* Describe the GraphSeries class.                                           */
/*****************************************************************************/

/* The wrapped toolkit object. */

static PyTypeObject graphSeriesType = {
	PyObject_HEAD_INIT(&PyType_Type)
	0,
	"__vpGraphSeries__",
	sizeof (pymodPyGraphSeries),
	0,
	pymodDeallocGraphSeries,
};

/* The properties of this class. */

propDef pymodPropGraphSeriesColor = {
	"color",
	instanceProp,
	offsetof(pymodPyGraphSeries,graphSeries.color),
	0,
	{PROP_VALID_NONE_OK, },
	{PROP_VALUE_IS_DEFAULT|PROP_VALUE_IS_NONE, },
	NULL,
	&pymodClassColor,
};

propDef pymodPropGraphSeriesValues = {
	"values",
	instanceProp,
	offsetof(pymodPyGraphSeries,graphSeries.values),
	PROP_FLAG_LIST,
	{PROP_VALID_NONE_OK|PROP_VALID_EMPTY_OK, },
	{0, },
	NULL,
	&pymodClassGraphPoint,
};

static classPropDef graphSeriesProperties[] = {
	{&pymodPropGraphSeriesColor, pymodNullHandler, },
	{&pymodPropGraphSeriesValues, pymodNullHandler, },
	{NULL}
};

/* The class definition. */
 
classDef pymodClassGraphSeries = {
	"GraphSeries",
	graphSeriesProperties,
	NULL,
	NULL,
	NULL,
	graphSeriesCtor,
	&graphSeriesType,
};


/*
 * The class ctor.
 */

static int graphSeriesCtor(pymodPyBase *self,PyObject *args,PyObject *kwds)
{
	if (pymodParseArgs(&pymodClassGraphSeries,self,args,kwds,graphSeriesProperties,"c") < 0)
		return -1;

	/* Nothing else to do. */

	return 0;
}
