/*
 * Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
 *
 * This module implements the Python part of the Grid class.
 */


#include <stddef.h>

#include "pymodint.h"


static int gridCtor(pymodPyBase *,PyObject *,PyObject *);


/*****************************************************************************/
/* Describe the Grid class.                                                  */
/*****************************************************************************/

/* The wrapped toolkit object. */

static PyTypeObject gridType = {
	PyObject_HEAD_INIT(&PyType_Type)
	0,
	"__vpGrid__",
	sizeof (pymodPyGrid),
	0,
	pymodDeallocGrid,
};

/* The properties of this class. */

static classPropDef gridProperties[] = {
	{&pymodPropContainerChildren, },
	{&pymodPropControlParent, },
	{&pymodPropControlColumn, },
	{&pymodPropControlRow, },
	{NULL}
};


/* The class definition. */
 
classDef pymodClassGrid = {
	"Grid",
	gridProperties,
	NULL,
	NULL,
	NULL,
	gridCtor,
	&gridType,
};


/*
 * The class ctor.
 */

static int gridCtor(pymodPyBase *self,PyObject *args,PyObject *kwds)
{
	pymodDataGrid *gd = &((pymodPyGrid *)self) -> grid;

	if (pymodParseArgs(&pymodClassGrid,self,args,kwds,gridProperties,"c") < 0)
		return -1;

	if (pymodInitControl1(self) < 0)
		return -1;

	/*
	 * Call the driver.
	 *
	 * parent is the parent toolkit object.
	 */

	if ((gd -> container.control.base.tkPtr = (*((pymodGridDrivers *)pymodClassGrid.drivers) -> ctor)(
			(PyObject *)self,
			gd -> container.control.parent -> container.control.base.tkPtr)) == NULL)
	{
		pymodBadToolkitCtor(pymodClassGrid.name);
		return -1;
	}

	pymodInitControl2(self);

	return 0;
}
