/*
 * Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
 *
 * This module implements the Python part of the HBox class.
 */


#include <stddef.h>

#include "pymodint.h"


static int hBoxCtor(pymodPyBase *,PyObject *,PyObject *);


/*****************************************************************************/
/* Describe the HBox class.                                                  */
/*****************************************************************************/

/* The wrapped toolkit object. */

static PyTypeObject hBoxType = {
	PyObject_HEAD_INIT(&PyType_Type)
	0,
	"__vpHBox__",
	sizeof (pymodPyHBox),
	0,
	pymodDeallocHBox,
};

/* The properties of this class. */

static classPropDef hBoxProperties[] = {
	{&pymodPropContainerChildren, },
	{&pymodPropControlParent, },
	{&pymodPropControlColumn, },
	{&pymodPropControlRow, },
	{NULL}
};


/* The class definition. */
 
classDef pymodClassHBox = {
	"HBox",
	hBoxProperties,
	NULL,
	NULL,
	NULL,
	hBoxCtor,
	&hBoxType,
};


/*
 * The class ctor.
 */

static int hBoxCtor(pymodPyBase *self,PyObject *args,PyObject *kwds)
{
	pymodDataHBox *vbd = &((pymodPyHBox *)self) -> hBox;

	if (pymodParseArgs(&pymodClassHBox,self,args,kwds,hBoxProperties,"c") < 0)
		return -1;

	if (pymodInitControl1(self) < 0)
		return -1;

	/*
	 * Call the driver.
	 *
	 * parent is the parent toolkit object.
	 */

	if ((vbd -> container.control.base.tkPtr = (*((pymodHBoxDrivers *)pymodClassHBox.drivers) -> ctor)(
			(PyObject *)self,
			vbd -> container.control.parent -> container.control.base.tkPtr)) == NULL)
	{
		pymodBadToolkitCtor(pymodClassHBox.name);
		return -1;
	}

	pymodInitControl2(self);

	return 0;
}
