/*
 * Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
 *
 * This module implements the Python part of the PieSlice class.
 */


#include <stddef.h>

#include "pymodint.h"


static int pieSliceCtor(pymodPyBase *,PyObject *,PyObject *);


/*****************************************************************************/
/* Describe the PieSlice class.                                              */
/*****************************************************************************/

/* The wrapped toolkit object. */

static PyTypeObject pieSliceType = {
	PyObject_HEAD_INIT(&PyType_Type)
	0,
	"__vpPieSlice__",
	sizeof (pymodPyPieSlice),
	0,
	pymodDeallocPieSlice,
};

/* The properties of this class. */

propDef pymodPropPieSliceColor = {
	"color",
	instanceProp,
	offsetof(pymodPyPieSlice,pieSlice.color),
	0,
	{0, },
	{0, },
	NULL,
	&pymodClassColor,
};

propDef pymodPropPieSliceLabel = {
	"label",
	stringProp,
	offsetof(pymodPyPieSlice,pieSlice.label),
	0,
	{PROP_VALID_NONE_OK, },
	{PROP_VALUE_IS_DEFAULT|PROP_VALUE_IS_NONE, },
};

propDef pymodPropPieSliceOffset = {
	"offset",
	intProp,
	offsetof(pymodPyPieSlice,pieSlice.offset),
	0,
	{0, },
	{PROP_VALUE_IS_DEFAULT, 0, NULL, 0},
};

propDef pymodPropPieSliceValue = {
	"value",
	doubleProp,
	offsetof(pymodPyPieSlice,pieSlice.value),
};

static classPropDef pieSliceProperties[] = {
	{&pymodPropPieSliceColor, pymodNullHandler, },
	{&pymodPropPieSliceLabel, pymodNullHandler, },
	{&pymodPropPieSliceOffset, pymodNullHandler, },
	{&pymodPropPieSliceValue, pymodNullHandler, },
	{NULL}
};

/* The class definition. */
 
classDef pymodClassPieSlice = {
	"PieSlice",
	pieSliceProperties,
	NULL,
	NULL,
	NULL,
	pieSliceCtor,
	&pieSliceType,
};


/*
 * The class ctor.
 */

static int pieSliceCtor(pymodPyBase *self,PyObject *args,PyObject *kwds)
{
	if (pymodParseArgs(&pymodClassPieSlice,self,args,kwds,pieSliceProperties,"c") < 0)
		return -1;

	/* Nothing else to do. */

	return 0;
}
