/*
 * Copyright (c) 2000 Phil Thompson (phil@river-bank.demon.co.uk)
 *
 * This module implements the Python part of the VBox class.
 */


#include <stddef.h>

#include "pymodint.h"


static int vBoxCtor(pymodPyBase *,PyObject *,PyObject *);


/*****************************************************************************/
/* Describe the VBox class.                                                  */
/*****************************************************************************/

/* The wrapped toolkit object. */

static PyTypeObject vBoxType = {
	PyObject_HEAD_INIT(&PyType_Type)
	0,
	"__vpVBox__",
	sizeof (pymodPyVBox),
	0,
	pymodDeallocVBox,
};

/* The properties of this class. */

static classPropDef vBoxProperties[] = {
	{&pymodPropContainerChildren, },
	{&pymodPropControlParent, },
	{&pymodPropControlColumn, },
	{&pymodPropControlRow, },
	{NULL}
};


/* The class definition. */
 
classDef pymodClassVBox = {
	"VBox",
	vBoxProperties,
	NULL,
	NULL,
	NULL,
	vBoxCtor,
	&vBoxType,
};


/*
 * The class ctor.
 */

static int vBoxCtor(pymodPyBase *self,PyObject *args,PyObject *kwds)
{
	pymodDataVBox *vbd = &((pymodPyVBox *)self) -> vBox;

	if (pymodParseArgs(&pymodClassVBox,self,args,kwds,vBoxProperties,"c") < 0)
		return -1;

	if (pymodInitControl1(self) < 0)
		return -1;

	/*
	 * Call the driver.
	 *
	 * parent is the parent toolkit object.
	 */

	if ((vbd -> container.control.base.tkPtr = (*((pymodVBoxDrivers *)pymodClassVBox.drivers) -> ctor)(
			(PyObject *)self,
			vbd -> container.control.parent -> container.control.base.tkPtr)) == NULL)
	{
		pymodBadToolkitCtor(pymodClassVBox.name);
		return -1;
	}

	pymodInitControl2(self);

	return 0;
}
